const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class PlansDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const plans = await db.plans.create(
      {
        id: data.id || undefined,

        code: data.code || null,
        name: data.name || null,
        period: data.period || null,
        price_mad: data.price_mad || null,
        limits: data.limits || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await plans.setAgences(data.agences || null, {
      transaction,
    });

    return plans;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const plansData = data.map((item, index) => ({
      id: item.id || undefined,

      code: item.code || null,
      name: item.name || null,
      period: item.period || null,
      price_mad: item.price_mad || null,
      limits: item.limits || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const plans = await db.plans.bulkCreate(plansData, { transaction });

    // For each item created, replace relation files

    return plans;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const plans = await db.plans.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.code !== undefined) updatePayload.code = data.code;

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.period !== undefined) updatePayload.period = data.period;

    if (data.price_mad !== undefined) updatePayload.price_mad = data.price_mad;

    if (data.limits !== undefined) updatePayload.limits = data.limits;

    updatePayload.updatedById = currentUser.id;

    await plans.update(updatePayload, { transaction });

    if (data.agences !== undefined) {
      await plans.setAgences(
        data.agences,

        { transaction },
      );
    }

    return plans;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const plans = await db.plans.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of plans) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of plans) {
        await record.destroy({ transaction });
      }
    });

    return plans;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const plans = await db.plans.findByPk(id, options);

    await plans.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await plans.destroy({
      transaction,
    });

    return plans;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const plans = await db.plans.findOne({ where }, { transaction });

    if (!plans) {
      return plans;
    }

    const output = plans.get({ plain: true });

    output.subscriptions_plan = await plans.getSubscriptions_plan({
      transaction,
    });

    output.tenants_plan = await plans.getTenants_plan({
      transaction,
    });

    output.agences = await plans.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.code) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('plans', 'code', filter.code),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('plans', 'name', filter.name),
        };
      }

      if (filter.limits) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('plans', 'limits', filter.limits),
        };
      }

      if (filter.price_madRange) {
        const [start, end] = filter.price_madRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            price_mad: {
              ...where.price_mad,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            price_mad: {
              ...where.price_mad,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.period) {
        where = {
          ...where,
          period: filter.period,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.plans.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('plans', 'name', query),
        ],
      };
    }

    const records = await db.plans.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
